.386
.model flat, stdcall
option casemap:none

	include TestUpdateWindow.inc

.code

start:
	mov hInstance, rv(GetModuleHandle,NULL)
;	mov CommandLine, rv(GetCommandLine)
	invoke InitCommonControlsEx, addr ICC
	invoke WinMain,hInstance,NULL,CommandLine,SW_SHOWDEFAULT
	invoke ExitProcess,eax

WinMain proc 	hInst:HINSTANCE, hPrevInst:HINSTANCE, CmdLine:LPSTR, CmdShow:DWORD
	LOCAL wc:WNDCLASSEX
	LOCAL msg:MSG
	LOCAL hWnd:HWND

	mov	wc.cbSize, SIZEOF WNDCLASSEX
	mov	wc.style, CS_HREDRAW or CS_VREDRAW
	mov	wc.lpfnWndProc, OFFSET WndProc
	mov	wc.cbClsExtra, NULL
	mov	wc.cbWndExtra, NULL
	push  hInstance
	pop	wc.hInstance
	mov	wc.hbrBackground, COLOR_BTNFACE+1
	mov	wc.lpszMenuName, NULL
	mov	wc.lpszClassName, OFFSET ClassName

	mov wc.hIcon, rv(LoadIcon, NULL, IDI_APPLICATION)
	mov	wc.hIconSm, eax

	mov wc.hCursor, rv(LoadCursor, NULL, IDC_ARROW)

	invoke RegisterClassEx, addr wc
	invoke CreateWindowEx, NULL, ADDR ClassName, ADDR AppName, \
		WS_OVERLAPPEDWINDOW, 400, 200, 400, 400, \
		NULL, NULL, hInst, NULL
		mov   hWnd, eax

	invoke ShowWindow, hWnd, SW_SHOWNORMAL
	invoke UpdateWindow, hWnd

	.while TRUE
		invoke GetMessage, ADDR msg, NULL, 0, 0
		.break .if (!eax)
		invoke TranslateMessage, ADDR msg
		invoke DispatchMessage, ADDR msg
	.endw

	mov     eax, msg.wParam
	ret
WinMain endp

WndProc proc 	hWin:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM
LOCAL PS	:PAINTSTRUCT
LOCAL hDC	:HDC	
	SWITCH uMsg
		CASE WM_CREATE
			push hWin
			pop hMain

			invoke CreateWindowEx, WS_EX_CLIENTEDGE, SADD("BUTTON"), SADD("MAKE RECT"), \
				WS_CHILD + BS_PUSHBUTTON + WS_VISIBLE, 50, 100, 50, 25, hWin, 1001, hInstance, NULL
		CASE WM_COMMAND
			.if wParam==1001	; Button
				invoke InvalidateRect, hWin, addr RT, FALSE
				invoke UpdateWindow, hWin
				mov hBG_Brush, rv(CreateSolidBrush, colRed)
				add RT.left, 31
				add RT.right, 30
			.endif
			ret
		CASE WM_PAINT
			mov hDC, rv(BeginPaint, hWin, addr PS)
			invoke FillRect, hDC, addr RT, hBG_Brush
			
			invoke EndPaint, hWin, addr PS
			ret

		CASE WM_DESTROY
			invoke PostQuitMessage, NULL

		DEFAULT
			invoke DefWindowProc, hWin, uMsg, wParam, lParam		
			ret
	ENDSW

	xor eax, eax
	ret
WndProc endp
end start
